image: maven:3.6-jdk-8
stages:
  - compilation
  - test
  - quality
  - packaging
  - deployment_document

variables:
  MVN_OPTS_SETTINGS: "--settings ./m2/setting.xml"
  MVN_OPTS_SKIP_TEST: "-DskipTests=true"
  

Compile:
  stage: compilation
  script:
    - mvn compile $MVN_OPTS_SETTINGS

Test:
  stage: test
  script:
    - mvn test $MVN_OPTS_SETTINGS

Codequality:
  stage: quality
  image: docker:latest
  variables:
    DOCKER_DRIVER: overlay
  allow_failure: true
  services:
    - docker:dind
  script:
    - export SP_VERSION=$(echo "$CI_SERVER_VERSION" | sed 's/^\([0-9]*\)\.\([0-9]*\).*/\1-\2-stable/')
    - docker run
        --env SOURCE_CODE="$PWD"
        --volume "$PWD":/code
        --volume /var/run/docker.sock:/var/run/docker.sock
        "registry.gitlab.com/gitlab-org/security-products/codequality:$SP_VERSION" /code
  artifacts:
    paths: [gl-code-quality-report.json]
    reports:
      codequality: gl-code-quality-report.json

Package:
  stage: packaging
  script:
    - mvn package $MVN_OPTS_SETTINGS $MVN_OPTS_SKIP_TEST
  artifacts:
    paths:
      - target/erp.war

Deploy:
 stage: deployment_document
 script:
   - mvn tomcat7:deploy $MVN_OPTS_SETTINGS $MVN_OPTS_SKIP_TEST

Document:
  stage: deployment_document
  script:
    - mvn clean site $MVN_OPTS_SETTINGS $MVN_OPTS_SKIP_TEST
    - mvn site:deploy
    - ls -a target/
